/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package call;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Scanner;

/**
 *
 * @author user
 */
public class Call {

    /**
     * @param args the command line arguments
     *
     */
    static String serverUrl = "";
    static String[] Commands = new String[7];
    static String[] CommandParameters = new String[7];

    public static void main(String[] args) {
        InitializeCommands();
        CommandParameters[0] = "Call";

        ShowGreetingMessage();

        ReadParameters();

        try {
            URL url = new URL(CreateUrl(serverUrl, Commands, CommandParameters));
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("GET");
            connection.connect();
                
            WriteFromInputStream(connection.getInputStream());
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    private static void ShowGreetingMessage() {
        System.out.println("This is a simple Ozeki Phone System XE demo written in Java.");
        System.out.println("It can be used to setup calls, send sms's and receive");
        System.out.println("corresponding delivery reports.");
        System.out.println("The source code of this demo can be downloaded from: ");
        System.out.println("link");
        System.out.println("-------------------------------------------------------------------------------");
    }

    private static void InitializeCommands() {
        Commands[0] = "Command";
        Commands[1] = "Dialed";
        Commands[2] = "ApiExtension";
        Commands[3] = "CallerId";
        Commands[4] = "CallerDisplayName";
        Commands[5] = "Url";
        Commands[6] = "ErrorUrl";
    }

    private static void ReadParameters() {
        serverUrl = Read("Server URL(default: http://192.168.115.175:7780/)", false);
        if (serverUrl != null && serverUrl.equals("")) {
            serverUrl = "http://192.168.115.175:7780/";
        }

        CommandParameters[1] = Read("Dialed", true);
        CommandParameters[2] = Read("ApiExtension(deafult: 9999)", false);
        if (CommandParameters[2] != null && CommandParameters[2].equals("")) {
            CommandParameters[2] = "9999";
        }
        CommandParameters[3] = Read("CallerId", false);
        CommandParameters[4] = Read("CallerDisplayName", false);
        CommandParameters[5] = Read("Url", true);
        CommandParameters[6] = Read("ErrorUrl", false);
    }

    private static String Read(String inputName, boolean readWhileEmpty) {
        String input;
        Scanner scannner = new Scanner(System.in);

        System.out.print(inputName + ": ");
        while (true) {
            input = scannner.nextLine();

            if (!readWhileEmpty) {
                return input;
            }

            if (input != null && !input.equals("")) {
                return input;
            }

            System.out.println(inputName + " cannot be empty.");
            System.out.print(inputName + ": ");
        }
    }

    private static String CreateUrl(String pServerUrl, String[] pCommands, String[] pCommandsValues) {
        String url = pServerUrl;

        if (url.charAt(url.length() - 1) != '/') {
            url += '/';
        }

        url += '?' + pCommands[0] + '=' + pCommandsValues[0];

        for (int i = 1; i <= pCommands.length - 1; i++) {
            url += '&' + pCommands[i] + '=' + pCommandsValues[i].replace(' ', '+');
        }

        return url;
    }

    private static void WriteFromInputStream(InputStream pInputStream) throws IOException {
        System.out.println("");
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(pInputStream));
        String line;
        while ((line = bufferedReader.readLine()) != null) {
            System.out.println(line);
        }
    }
}
